void inline 
list_link( struct arp_record *a, struct arp_record *b )
{
        a->next = b;
        b->prev = a;
}

void inline
list_init( struct arp_record * cur)
{
/*
  DEBUG( "  cur=%p,     cur->next=%p,     cur->prev=%p.\n\n",
            cur   ,     cur->next   ,     cur->prev );
 */
  list_link( cur, cur );

/*
  DEBUG( "  cur=%p,     cur->next=%p,     cur->prev=%p.\n\n",
            cur   ,     cur->next   ,     cur->prev );
 */

}

void inline
list_prepend( struct arp_record ** head, struct arp_record * cur )
{
  if ( ! *head ) { list_init( cur ) ; *head = cur ; return ; }

  struct arp_record * first = ( *head )->next ;

  list_link( *head, cur );
  list_link( cur, first );

}

void inline
list_append( struct arp_record ** head, struct arp_record * cur)
{
  if ( ! *head ) { *head = cur ; list_init( cur ) ; }

  struct arp_record * last = ( *head )->prev ;

/*
  DEBUG( "  cur=%p,     cur->next=%p,     cur->prev=%p.\n\n",
            cur   ,     cur->next   ,     cur->prev );
  DEBUG( "*head=%p, (*head)->next=%p, (*head)->prev=%p.\n\n",
          *head   , (*head)->next   , (*head)->prev );
 */

  list_link( cur, *head );
  list_link( last, cur  );

/*
  DEBUG( "  cur=%p,     cur->next=%p,     cur->prev=%p.\n\n",
            cur   ,     cur->next   ,     cur->prev );
  DEBUG( "*head=%p, (*head)->next=%p, (*head)->prev=%p.\n\n",
          *head   , (*head)->next   , (*head)->prev );
 */

}

void inline
list_remove( struct arp_record ** head, struct arp_record * cur)
{

/*
  DEBUG( "  cur=%p,     cur->next=%p,     cur->prev=%p.\n\n",
            cur   ,     cur->next   ,     cur->prev );
  DEBUG( "*head=%p, (*head)->next=%p, (*head)->prev=%p.\n\n",
          *head   , (*head)->next   , (*head)->prev );
 */

  if ( *head == cur->next && *head == cur->prev && *head == cur )
  {
    *head = NULL;
  } else {
    *head = cur->next;
    list_link( cur->prev, cur->next );
  }
  cur->next = NULL;
  cur->prev = NULL;

/*
  DEBUG( "  cur=%p,     cur->next=%p,     cur->prev=%p.\n\n",
            cur   ,     cur->next   ,     cur->prev );
  DEBUG( "*head=%p, (*head)->next=%p, (*head)->prev=%p.\n\n",
          *head   , (*head)->next   , (*head)->prev );
 */

}

int
list_length( struct arp_record * cur )
{
  struct arp_record * head = cur;

  int i = 0;

  if ( ! cur ) return i ; /* NULL pointer, zero items */

  ++i; /* Argh!  Silly lines of code ahead. */

  if ( head == cur->next ) return i ;

  cur = cur->next;

  do
  {
    ++i;
    cur = cur->next ;
  } while ( cur != head );

  // DEBUG( "%s about to return %d.\n", __func__, i );

  return  i ;

}

/* eof */
